if modulestate==nil then modulestate={} end
if modulename==nil then modulename={} end

dofile(mdir.."/globalhooks.lua")

modulename["rings"]="Goa'uld Ring Transporter"
modulename["asgard"]="Asgard Teleporter"
modulename["iris"]="Iris"
modulename["gdo"]="GDO"
modulename["rp"]="Roleplay"

if (rings) then
	modulestate["rings"]=true
else
	modulestate["rings"]=false
end

if (asgard) then
	modulestate["asgard"]=true
else
	modulestate["asgard"]=false
end

if (iris) then
	modulestate["iris"]=true
else
	modulestate["iris"]=false
end

if (gdo) then
	modulestate["gdo"]=true
else
	modulestate["gdo"]=false
end

if (rp) then
	modulestate["rp"]=true
else
	modulestate["rp"]=false
end

if (modulestate["rings"]==true) then
	dofile(mdir.."/ringtransporter.lua")
	print("115110255Stargate: adding extra module "..modulename["rings"])
end
if (modulestate["asgard"]==true) then
	dofile(mdir.."/asgard.lua")
	print("115110255ADDED SG MODULE: "..modulename["asgard"])
end
if (modulestate["iris"]==true) then
	dofile(mdir.."/iris.lua")
	print("115110255Stargate: adding extra module "..modulename["iris"])
end
if (modulestate["gdo"]==true) then
	dofile(mdir.."/gdo.lua")
	print("115110255Stargate: adding extra module "..modulename["gdo"])
end
if (modulestate["rp"]==true) then
	dofile(mdir.."/roleplay.lua")
	print("115110255Stargate: adding extra module "..modulename["rp"])
end

function addonCheck(a)
	if (modulestate[a]==true) then
		return modulename[a]
	else
		return ""
	end
end

function sg.modules.extrasmenu(id)
	menu(id,"Stargate Extras,"..addonCheck("rings")..","..addonCheck("asgard"))
end
