sg.modules.asgard={}

function doublearray(m,n,k)
    local a, x, y = {}
    for x = 0, m do a[x] = {}
        for y = 0, n do
            a[x][y] = k
        end
    end
    return a
end

sg.modules.asgard.limit=128
sg.modules.asgard.currentid=1

sg.modules.asgard.pos=doublearray(sg.modules.asgard.limit,2,0)
sg.modules.asgard.dpos=doublearray(sg.modules.asgard.limit,2,0)
sg.modules.asgard.opos=doublearray(sg.modules.asgard.limit,2,0)
sg.modules.asgard.owner=initArray2(sg.modules.asgard.limit,0)

sg.modules.asgard.image=initArray2(sg.modules.asgard.limit,0)
sg.modules.asgard.glow=initArray2(32,0)
sg.modules.asgard.dglow=initArray2(32,0)

sg.modules.asgard.trackingowner=initArray2(sg.modules.asgard.limit,false)

sg.modules.asgard.idstack=initArray2(32,0)
sg.modules.asgard.enteringopos=initArray2(32,false)
sg.modules.asgard.enteringdpos=initArray2(32,false)
sg.modules.asgard.enteringoply=initArray2(32,false)
sg.modules.asgard.enteringdply=initArray2(32,false)
sg.modules.asgard.trackingoply=initArray2(sg.modules.asgard.limit,false)
sg.modules.asgard.trackingdply=initArray2(sg.modules.asgard.limit,false)
sg.modules.asgard.trackedply=initArray2(sg.modules.asgard.limit,0)
sg.modules.asgard.dtrackedply=initArray2(sg.modules.asgard.limit,0)

sg.modules.asgard.plypos=doublearray(32,2,0)

function sg.modules.asgard.create(ply,x,y)
	sg.modules.asgard.image[sg.modules.asgard.currentid]=image("gfx/asgard.png",x,y,0)
	sg.modules.asgard.pos[sg.modules.asgard.currentid][1]=x
	sg.modules.asgard.pos[sg.modules.asgard.currentid][2]=y
	sg.modules.asgard.pos[sg.modules.asgard.currentid][3]=math.floor(x/32)
	sg.modules.asgard.pos[sg.modules.asgard.currentid][4]=math.floor(y/32)
	sg.modules.asgard.owner[sg.modules.asgard.currentid]=ply
	sg.modules.asgard.trackingowner[sg.modules.asgard.currentid]=false
	sg.modules.asgard.currentid=sg.modules.asgard.currentid+1
end

function sg.modules.asgard.remove(id)
	freeimage(sg.modules.asgard[id])
	sg.modules.asgard.image[id]=0
	sg.modules.asgard.pos[sg.modules.asgard.currentid][1]=0
	sg.modules.asgard.pos[sg.modules.asgard.currentid][2]=0
	sg.modules.asgard.owner[sg.modules.asgard.currentid]=0
end

function sg.modules.asgard.teleport(id,ply)
	if (NearBy(player(ply,"x"),player(ply,"y"),sg.modules.asgard.opos[id][1],sg.modules.asgard.opos[id][2],64,64)) then
		parse("speedmod "..ply.." -100")
		sg.modules.asgard.glow[ply]=image("gfx/sprites/flare1.bmp",player(ply,"x"),player(ply,"y"),3)
		sg.modules.asgard.dglow[ply]=image("gfx/sprites/flare1.bmp",sg.modules.asgard.dpos[id][1],sg.modules.asgard.dpos[id][2],3)
		imageblend(sg.modules.asgard.glow[ply],1)
		imageblend(sg.modules.asgard.dglow[ply],1)
		imagealpha(sg.modules.asgard.glow[ply],0)
		imagealpha(sg.modules.asgard.dglow[ply],0)
		tween_alpha(sg.modules.asgard.glow[ply],2000,1)
		tween_alpha(sg.modules.asgard.dglow[ply],2000,1)
		timer(2000,"parse","lua tween_alpha(sg.modules.asgard.glow["..ply.."],500,0)")
		timer(2000,"parse","lua tween_alpha(sg.modules.asgard.dglow["..ply.."],500,0)")
		timer(2000,"parse","setpos "..ply.." "..sg.modules.asgard.dpos[id][1].." "..sg.modules.asgard.dpos[id][2])
		timer(2500,"parse","lua freeimage(sg.modules.asgard.glow["..ply.."])")
		timer(2500,"parse","lua freeimage(sg.modules.asgard.dglow["..ply.."])")
		timer(2500,"parse","speedmod "..ply.." 0")
		sound3("stargate/asgard_beamup.ogg",player(ply,"x"),player(ply,"y"),128,128)
		sound3("stargate/asgard_beamup.ogg",(sg.modules.asgard.dpos[id][1]+(sg.modules.asgard.dpos[id][1]-player(ply,"x"))),(sg.modules.asgard.dpos[id][2]+(sg.modules.asgard.dpos[id][2]-player(ply,"y"))),128,128)
	end
end

function sg.modules.asgard.backteleport(id,ply)
	if (NearBy(player(ply,"x"),player(ply,"y"),sg.modules.asgard.dpos[id][1],sg.modules.asgard.dpos[id][2],64,64)) then
		parse("speedmod "..ply.." -100")
		sg.modules.asgard.glow[ply]=image("gfx/sprites/flare1.bmp",player(ply,"x"),player(ply,"y"),3)
		sg.modules.asgard.dglow[ply]=image("gfx/sprites/flare1.bmp",sg.modules.asgard.opos[id][1],sg.modules.asgard.opos[id][2],3)
		imageblend(sg.modules.asgard.glow[ply],1)
		imageblend(sg.modules.asgard.dglow[ply],1)
		imagealpha(sg.modules.asgard.glow[ply],0)
		imagealpha(sg.modules.asgard.dglow[ply],0)
		tween_alpha(sg.modules.asgard.glow[ply],2000,1)
		tween_alpha(sg.modules.asgard.dglow[ply],2000,1)
		timer(2000,"parse","lua tween_alpha(sg.modules.asgard.glow["..ply.."],500,0)")
		timer(2000,"parse","lua tween_alpha(sg.modules.asgard.dglow["..ply.."],500,0)")
		timer(2000,"parse","setpos "..ply.." "..sg.modules.asgard.opos[id][1].." "..sg.modules.asgard.opos[id][2])
		timer(2500,"parse","lua freeimage(sg.modules.asgard.glow["..ply.."])")
		timer(2500,"parse","lua freeimage(sg.modules.asgard.dglow["..ply.."])")
		timer(2500,"parse","speedmod "..ply.." 0")
		sound3("stargate/asgard_beamup.ogg",player(ply,"x"),player(ply,"y"),128,128)
		sound3("stargate/asgard_beamup.ogg",sg.modules.asgard.opos[id][1],sg.modules.asgard.opos[id][2],128,128)
	end
end

addhook("menu","sg.modules.asgard.spawnmenu")
function sg.modules.asgard.spawnmenu(id,menu,sel)
	if (menu=="Stargate Extras" and sel==2) then
		sg.modules.asgard.create(id,player(id,"x"),player(id,"y"))
	end
	if (menu=="Asgard Teleporter") then
		if (sel==1) then
			sg.modules.asgard.trackingowner[sg.modules.asgard.idstack[id]]=false
			sg.modules.asgard.trackingoply[sg.modules.asgard.idstack[id]]=false
			sg.modules.asgard.enteringopos[id]=true
			msg2(id,"Move to the desired origin position and write '!' in chat (without quotes)")
		end
		if (sel==2) then
			sg.modules.asgard.trackingdply[sg.modules.asgard.idstack[id]]=false
			sg.modules.asgard.enteringdpos[id]=true
			msg2(id,"Move to the desired destination position and write '!' in chat (without quotes)")
		end
		if (sel==3) then
			sg.modules.asgard.trackingoply[sg.modules.asgard.idstack[id]]=false
			sg.modules.asgard.trackingowner[sg.modules.asgard.idstack[id]]=true
		end
		if (sel==4) then
			sg.modules.asgard.trackingowner[sg.modules.asgard.idstack[id]]=false
			sg.modules.asgard.enteringoply[id]=true
			msg2(id,"Write the ID of the player to track in the chat.")
		end
		if (sel==5) then
			sg.modules.asgard.enteringdply[id]=true
			msg2(id,"Write the ID of the player to track in the chat.")
		end
		if (sel==6) then
			for ply=1,#player(0,"table") do
				if (player(ply,"exists")) then
					sg.modules.asgard.teleport(sg.modules.asgard.idstack[id],ply)
				end
			end
		end
		if (sel==7) then
			for ply=1,#player(0,"table") do
				if (player(ply,"exists")) then
					sg.modules.asgard.backteleport(sg.modules.asgard.idstack[id],ply)
				end
			end
		end
		if (sel==8) then
			sg.modules.asgard.remove(sg.modules.asgard.idstack[id])
			sg.modules.asgard.idstack[id]=0
		end
	end
end

function sg.modules.asgard.tmenu(id,ply)
	menu(ply,"Asgard Teleporter@b,Set Origin Position,Set Destination Position,Track Owner for Origin Position,Track Player for Origin Position,Track Player for Destination Position,Beam,Retrieve,Remove")
	sg.modules.asgard.idstack[ply]=id
end

addhook("use","sg.modules.asgard.telemenu")
function sg.modules.asgard.telemenu(id)
	for asg=1,sg.modules.asgard.currentid-1 do
		if (player(id,"tilex")==sg.modules.asgard.pos[asg][3] and player(id,"tiley")==sg.modules.asgard.pos[asg][4]) then
			sg.modules.asgard.tmenu(asg,id)
		end
	end
end

function whatid()
	if sg.modules.asgard.currentid>1 then 
		return sg.modules.asgard.currentid-1 
	else 
		return 1 
	end 
end

addhook("move","sg.modules.asgard.updatecurpos")
function sg.modules.asgard.updatecurpos(id,x,y)
	sg.modules.asgard.plypos[id][1]=x
	sg.modules.asgard.plypos[id][2]=y
	for asg=1,whatid() do
		if (sg.modules.asgard.trackingowner[asg]) then
			if (sg.modules.asgard.owner[asg]~=0 and player(sg.modules.asgard.owner[asg],"exists")) then
				sg.modules.asgard.opos[asg][1]=x
				sg.modules.asgard.opos[asg][2]=y
			end
		end
		if (sg.modules.asgard.trackingoply[asg]) then
			if (id==sg.modules.asgard.trackedply[asg]) then
				sg.modules.asgard.opos[asg][1]=x
				sg.modules.asgard.opos[asg][2]=y
			end
		end
		if (sg.modules.asgard.trackingdply[asg]) then
			if (id==sg.modules.asgard.dtrackedply[asg]) then
				sg.modules.asgard.dpos[asg][1]=x
				sg.modules.asgard.dpos[asg][2]=y
			end
		end
	end
end
