sg.modules.iris={}

sg.modules.iris.limit=128

sg.modules.iris.currentid=1

sg.modules.iris.gate=initArray2(sg.modules.iris.limit,0)
sg.modules.iris.owner=initArray2(sg.modules.iris.limit,0)
sg.modules.iris.closed=initArray2(sg.modules.iris.limit,false)
sg.modules.iris.gclosed=initArray2(gatelimit,false)
sg.modules.iris.type=initArray2(sg.modules.iris.limit,"")
sg.modules.iris.image=initArray2(sg.modules.iris.limit,0)
sg.modules.iris.iris=initArray2(gatelimit,0)

function sg.init.removegate(gate)
    freeimage(sg.init.image[gate])
    freeimage(sg.init.dhdimage[gate])
    sg.init.gatepos[gate][1]=0
    sg.init.gatepos[gate][2]=0
    sg.init.gatepos[gate][3]=0
    sg.init.gatepos[gate][4]=0
    sg.init.gatepos[gate][5]=0
    sg.init.gatepos[gate][6]=0
    sg.init.dhdpos[gate][1]=0
    sg.init.dhdpos[gate][2]=0
    sg.init.dhdpos[gate][3]=0
    sg.init.dhdpos[gate][4]=0
    sg.init.dhdpos[gate][5]=0
    sg.init.dhdpos[gate][6]=0
    sg.init.gateexists[gate]=false
    sg.init.image[gate]=0
    sg.init.dhdimage[gate]=0
    sg.init.sgtype[gate]=""
	sg.init.gateowner[gate]=0
    sg.dial.sgaddress[gate]=""
    sg.dial.sgname[gate]=""
    sg.dial.EHsprite[gate]=0
    sg.dial.isopened[gate]=false
    sg.dial.isdialing[gate]=false
    sg.dial.openedto[gate]=0
    sg.dial.leadergate[gate]=false
	sg.modules.iris.remove(sg.modules.iris.iris[gate])
end

addhook("startround","cleanirises")
function cleanirises()
	for iris=1,sg.modules.iris.currentid-1 do
		sg.modules.iris.remove(iris)
	end
end

function sg.modules.iris.create(ply,gate,type)
	if (type=="Tauri") then
		sg.modules.iris.image[sg.modules.iris.currentid]=image("gfx/iris.png",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6],1)
		sg.modules.iris.gate[sg.modules.iris.currentid]=gate
		sg.modules.iris.owner[sg.modules.iris.currentid]=ply
		sg.modules.iris.type[sg.modules.iris.currentid]="Tauri"
		sg.modules.iris.closed[sg.modules.iris.currentid]=true
		sg.modules.iris.gclosed[sg.modules.iris.gate[sg.modules.iris.currentid]]=true
		sg.modules.iris.iris[gate]=sg.modules.iris.currentid
		sg.modules.iris.currentid=sg.modules.iris.currentid+1
	elseif (type=="Atlantis") then
		sg.modules.iris.image[sg.modules.iris.currentid]=image("gfx/iris_atl.png",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6],1)
		imageblend(sg.modules.iris.image[sg.modules.iris.currentid],1)
		sg.modules.iris.gate[sg.modules.iris.currentid]=gate
		sg.modules.iris.owner[sg.modules.iris.currentid]=ply
		sg.modules.iris.type[sg.modules.iris.currentid]="Atlantis"
		sg.modules.iris.closed[sg.modules.iris.currentid]=true
		sg.modules.iris.gclosed[sg.modules.iris.gate[sg.modules.iris.currentid]]=true
		sg.modules.iris.iris[gate]=sg.modules.iris.currentid
		sg.modules.iris.currentid=sg.modules.iris.currentid+1
	end
end

function sg.modules.iris.open(ply,id)
	if (sg.modules.iris.closed[id]) then
		if (sg.modules.iris.type[id]=="Tauri") then
			sound3("stargate/iris_open.ogg",sg.init.gatepos[sg.modules.iris.gate[id]][1],sg.init.gatepos[sg.modules.iris.gate[id]][2],128,128)
			timer(1000,"parse","lua freeimage("..sg.modules.iris.image[id]..")")
			timer(1000,"parse","lua sg.modules.iris.image["..id.."]=image(\"gfx/iris2.png\","..sg.init.gatepos[sg.modules.iris.gate[id]][5]..","..sg.init.gatepos[sg.modules.iris.gate[id]][6]..",1)")
			timer(3000,"parse","lua freeimage("..sg.modules.iris.image[id]..")")
			timer(3000,"parse","lua sg.modules.iris.closed["..id.."]=false")
			timer(3000,"parse","lua sg.modules.iris.gclosed["..sg.modules.iris.gate[id].."]=false")
		elseif (sg.modules.iris.type[id]=="Atlantis") then
			sound3("stargate/iris_atlantis_open.ogg",sg.init.gatepos[sg.modules.iris.gate[id]][5],sg.init.gatepos[sg.modules.iris.gate[id]][6],128,128)
			freeimage(sg.modules.iris.image[id])
			sg.modules.iris.closed[id]=false
			sg.modules.iris.gclosed[sg.modules.iris.gate[id]]=false
		end
	end
end

function sg.modules.iris.close(ply,id)
	if not (sg.modules.iris.closed[id]) then
		if (sg.modules.iris.type[id]=="Tauri") then
			sound3("stargate/iris_close.ogg",sg.init.gatepos[sg.modules.iris.gate[id]][1],sg.init.gatepos[sg.modules.iris.gate[id]][2],128,128)
			timer(1000,"parse","lua freeimage("..sg.modules.iris.image[id]..")")
			timer(1000,"parse","lua sg.modules.iris.image["..id.."]=image(\"gfx/iris2.png\","..sg.init.gatepos[sg.modules.iris.gate[id]][5]..","..sg.init.gatepos[sg.modules.iris.gate[id]][6]..",1)")
			timer(3000,"parse","lua freeimage("..sg.modules.iris.image[id]..")")
			timer(3000,"parse","lua sg.modules.iris.image["..id.."]=image(\"gfx/iris.png\","..sg.init.gatepos[sg.modules.iris.gate[id]][5]..","..sg.init.gatepos[sg.modules.iris.gate[id]][6]..",1)")
			timer(3000,"parse","lua sg.modules.iris.closed["..id.."]=true")
			timer(3000,"parse","lua sg.modules.iris.gclosed["..sg.modules.iris.gate[id].."]=true")
		elseif (sg.modules.iris.type[id]=="Atlantis") then
			sound3("stargate/iris_atlantis_close.ogg",sg.init.gatepos[sg.modules.iris.gate[id]][1],sg.init.gatepos[sg.modules.iris.gate[id]][2],128,128)
			sg.modules.iris.image[id]=image("gfx/iris_atl.png",sg.init.gatepos[sg.modules.iris.gate[id]][5],sg.init.gatepos[sg.modules.iris.gate[id]][6],1)
			imageblend(sg.modules.iris.image[id],1)
			sg.modules.iris.closed[id]=true
			sg.modules.iris.gclosed[sg.modules.iris.gate[id]]=true
		end
	end
end

function sg.modules.iris.remove(id)
	freeimage(sg.modules.iris.image[id])
	sg.modules.iris.image[id]=0
	sg.modules.iris.iris[sg.modules.iris.gate[id]]=0
	sg.modules.iris.gate[id]=0
	sg.modules.iris.owner[id]=0
	sg.modules.iris.type[id]=""
	sg.modules.iris.closed[id]=false
	sg.modules.iris.gclosed[id]=false
end

function sg.modules.iris.check(gate)
	if (sg.modules.iris.closed[sg.modules.iris.iris[gate]]) then
		return 0
	else
		return 1
	end
end

function sg.dial.dial(id,gate1,gate2)
    if (sg.init.gateexists[gate2]==true and sg.dial.isopened[gate2]==false and sg.dial.isopened[gate1]==false and sg.dial.gateinitialized[gate2]==true and gate1~=gate2 and not sg.dial.isdialing[gate1] and not sg.dial.isdialing[gate2]) then
        sg.dial.isdialing[gate1]=true
		sg.dial.isdialing[gate2]=true
		sg.dial.leadergate[gate1]=true
		sg.dial.leadergate[gate2]=false
		sg.dial.openedto[gate1]=gate2
		sg.dial.openedto[gate2]=gate1
		soundSequence(gate2)
		chevronSequence(gate1,0)
		if (sg.init.sgtype[gate1]=="Milky Way") then
			sound3("stargate/roll_long.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			sound3("stargate/chevron_dhd.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			timer(1000,"parse","lua sound3(\"stargate/chevron_dhd.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)",5)
			timer(6000,"parse","lua sound3(\"stargate/chevron_lock.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			timer(7000,"parse","lua sound3(\"stargate/open.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			chevronSequence(gate2,1)
        elseif (sg.init.sgtype[gate1]=="Atlantis") then
			sound3("stargate/atl_roll.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			sound3("stargate/atl_chevron.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			timer(1000,"parse","lua sound3(\"stargate/atl_chevron.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)",6)
			timer(6000,"parse","lua sound3(\"stargate/atl_open.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			chevronSequence(gate2,1)
        elseif (sg.init.sgtype[gate1]=="Universe") then
			sound3("stargate/sgu_roll.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			sound3("stargate/sgu_chevron1.ogg",sg.init.gatepos[gate1][1],sg.init.gatepos[gate1][2],256,256)
			timer(1000,"parse","lua sound3(\"stargate/sgu_chevron1.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)",6)
			timer(4000,"parse","lua sound3(\"stargate/sgu_roll.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
            timer(7000,"parse","lua sound3(\"stargate/sgu_open.ogg\",sg.init.gatepos["..gate1.."][1],sg.init.gatepos["..gate1.."][2],256,256)")
			chevronSequence(gate2,1)
        end
		local ch=sg.modules.iris.check(gate1)
		local ch2=sg.modules.iris.check(gate2)
		timer(7000,"parse","lua sg.dial.EHsprite["..gate1.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate1][5]..","..sg.init.gatepos[gate1][6]..","..ch..")")
        timer(7000,"parse","lua sg.dial.EHsprite["..gate2.."]=image(\"gfx/eventhorizon.png\","..sg.init.gatepos[gate2][5]..","..sg.init.gatepos[gate2][6]..","..ch2..")")
		timer(7000,"parse","lua sg.dial.isopened["..gate1.."]=true")
		timer(7000,"parse","lua sg.dial.isopened["..gate2.."]=true")
		timer(7000,"parse","lua sg.dial.isdialing["..gate1.."]=false")
		timer(7000,"parse","lua sg.dial.isdialing["..gate2.."]=false")
    end
end

function sg.dial.close(id,gate)
    if (sg.dial.isopened[gate]==true) then
		local ch=sg.modules.iris.check(gate)
		local ch2=sg.modules.iris.check(sg.dial.openedto[gate])
        sound3("stargate/gate_close.ogg",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6],256,256)
		sound3("stargate/gate_close.ogg",sg.init.gatepos[sg.dial.openedto[gate]][5],sg.init.gatepos[sg.dial.openedto[gate]][6],256,256)
        timer(1000,"parse","lua freeimage(sg.dial.EHsprite["..gate.."])")
        timer(1000,"parse","lua freeimage(sg.dial.EHsprite["..sg.dial.openedto[gate].."])")
		timer(1000,"parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/dewormhole1.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..","..ch..")")
		timer(1000,"parse","lua sg.dial.EHsprite["..sg.dial.openedto[gate].."]=image(\"gfx/dewormhole1.png\","..sg.init.gatepos[sg.dial.openedto[gate]][5]..","..sg.init.gatepos[sg.dial.openedto[gate]][6]..","..ch2..")")
		timer(2000,"parse","lua freeimage(sg.dial.EHsprite["..gate.."])")
        timer(2000,"parse","lua freeimage(sg.dial.EHsprite["..sg.dial.openedto[gate].."])")
		timer(2000,"parse","lua sg.dial.EHsprite["..gate.."]=image(\"gfx/dewormhole.png\","..sg.init.gatepos[gate][5]..","..sg.init.gatepos[gate][6]..","..ch..")")
		timer(2000,"parse","lua sg.dial.EHsprite["..sg.dial.openedto[gate].."]=image(\"gfx/dewormhole.png\","..sg.init.gatepos[sg.dial.openedto[gate]][5]..","..sg.init.gatepos[sg.dial.openedto[gate]][6]..","..ch2..")")
        timer(3000,"parse","lua freeimage(sg.dial.EHsprite["..gate.."])")
		timer(3000,"parse","lua freeimage(sg.dial.EHsprite["..sg.dial.openedto[gate].."])")
		for c=1,7 do
			--if (sg.init.sgtype[gate]~="Universe") then -- universe gate doesn't have chevron lights -- it has now
				timer(2000,"parse","lua freeimage("..sg.dial.chevron[gate][c]..")")
				timer(2000,"parse","lua sg.dial.chevron["..gate.."]["..c.."]=0")
			--end
			--if (sg.init.sgtype[sg.dial.openedto[gate]]~="Universe") then -- universe gate doesn't have chevron lights, again -- forget it it has now
				timer(2000,"parse","lua freeimage("..sg.dial.chevron[sg.dial.openedto[gate]][c]..")")
				timer(2000,"parse","lua sg.dial.chevron["..sg.dial.openedto[gate].."]["..c.."]=0")
			--end
		end
        sg.dial.isopened[gate]=false
        sg.dial.isopened[sg.dial.openedto[gate]]=false
        sg.dial.openedto[gate]=0
    end
end

addhook("movetile","sg.travel.through")
function sg.travel.through(id,x,y)
    for gate=1,sg.init.currentsgid do
        if (sg.dial.isopened[gate] and sg.dial.leadergate[gate]) then
            if (x==sg.init.gatepos[gate][3] and y==sg.init.gatepos[gate][4]) then
                freetimer("parse","lua sg.dial.close("..id..","..gate..")")
				if (sg.modules.iris.gclosed[sg.dial.openedto[gate]]) then
					if (sg.modules.iris.type[sg.modules.iris.iris[sg.dial.openedto[gate]]]=="Tauri") then
						sound3("stargate/iris_hit.ogg",sg.init.gatepos[sg.dial.openedto[gate]][5],sg.init.gatepos[sg.dial.openedto[gate]][6],128,128)
					elseif (sg.modules.iris.type[sg.modules.iris.iris[sg.dial.openedto[gate]]]=="Atlantis") then
						sound3("stargate/iris_hit_atlantis.ogg",sg.init.gatepos[sg.dial.openedto[gate]][5],sg.init.gatepos[sg.dial.openedto[gate]][6],128,128)
					end
					parse("customkill 0 Iris "..id)
					msg(gate)
					msg(sg.modules.iris.iris[gate])
					msg(sg.modules.iris.type[sg.modules.iris.iris[gate]])
				else
					if (not sg.modules.iris.gclosed[sg.dial.openedto[gate]]) then
						parse("setpos "..id.." "..sg.init.gatepos[sg.dial.openedto[gate]][1].." "..sg.init.gatepos[sg.dial.openedto[gate]][2]+96)
						sound3("stargate/teleport_8.ogg",sg.init.gatepos[sg.dial.openedto[gate]][1],sg.init.gatepos[sg.dial.openedto[gate]][2],256,256)
					end
				end
				sound3("stargate/teleport_8.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
				timer(3000,"parse","lua sg.dial.close("..id..","..gate..")")
            end
        elseif (sg.dial.isopened[gate] and sg.dial.leadergate[gate]==false) then
            if (x==sg.init.gatepos[gate][3] and y==sg.init.gatepos[gate][4]) then
                parse("customkill 0 Stargate "..id) --to kill them dumbasses trying to go thru the destination gate. stargates are one-way only!
				sound3("stargate/teleport_8.ogg",sg.init.gatepos[gate][1],sg.init.gatepos[gate][2],256,256)
				sound3("stargate/teleport_8.ogg",sg.init.gatepos[sg.dial.openedto[gate]][1],sg.init.gatepos[sg.dial.openedto[gate]][2],256,256)
            end
        end
    end
end

function sg.dial.gatemenu(id,gate)
	if (id==sg.init.gateowner[gate]) then
		if (sg.modules.iris.iris[gate]==0) then
			menu(id,"Gate Menu,Set Address,Set Name,Dial Manually,Remove,Install an iris (Human),Install an iris (Atlantis)")
		else
			menu(id,"Gate Menu,Set Address,Set Name,Dial Manually,Remove")
		end
		sg.dial.idstack[id]=gate
	else
		menu(id,"Gate Menu,,,Dial Manually")
		sg.dial.idstack[id]=gate
	end
end

function sg.dial.gatedial(id,gate,page)
    if (sg.dial.isopened[gate]==true) then
		if (sg.modules.iris.iris[gate]~=0) then
			menu(id,"Dialing Menu (Gate Opened),Close,Toggle Iris")
		else
			menu(id,"Dialing Menu (Gate Opened),Close")
		end
        sg.dial.idstack[id]=gate
    else
		if (sg.modules.iris.iris[gate]~=0) then
			menu(id,"Dialing Menu,Dial a gate,Toggle Iris")
		else
			menu(id,"Dialing Menu,Dial a gate")
		end
        sg.dial.idstack[id]=gate
    end
    if (sg.dial.isdialing[gate]==true) then
        if (sg.modules.iris.iris[gate]~=0) then
			menu(id,"Dialing Menu,,Toggle Iris")
		else
			menu(id,"Dialing Menu,")
		end
		sg.dial.idstack[id]=gate
    end
end

addhook("use","sg.dial.address")
function sg.dial.address(id,e,d,x,y)
    for gate=1,sg.init.currentsgid do
        if (player(id,"tilex")==sg.init.gatepos[gate][3]) and (player(id,"tiley")==sg.init.gatepos[gate][4]) then
            sg.dial.gatemenu(id,gate)
        end
        if (player(id,"tilex")==sg.init.dhdpos[gate][3] and player(id,"tiley")==sg.init.dhdpos[gate][4]) then
            sg.dial.gatedial(id,gate,1)
        end
    end
end

addhook("menu","sg.dial.menuselect")
function sg.dial.menuselect(id,menu,sel)
    if (menu=="Gate Menu") then
        if (sel==1) then
            sg.dial.setaddressmode[id]=true
            msg2(id,"Please write a 6-symbol address in the chat.")
        end
        if (sel==2) then
            sg.dial.setnamemode[id]=true
            msg2(id,"Write a name for the gate used for easier search.")
        end
		if (sel==3) then
			sg.dial.ismentering[id]=true
            msg2(id,"Enter a gate address in chat to dial it.")
		end
        if (sel==4) then
            sg.init.removegate(sg.dial.idstack[id])
			sg.dial.idstack[id]=0
        end
		if (sel==5) then
			sg.modules.iris.create(id,sg.dial.idstack[id],"Tauri")
		end
		if (sel==6) then
			sg.modules.iris.create(id,sg.dial.idstack[id],"Atlantis")
		end
    end
    if (menu=="Dialing Menu (Gate Opened)") then
        if (sel==1) then
            sg.dial.close(id,sg.dial.idstack[id])
        end
		if (sel==2) then
			if (sg.modules.iris.gclosed[sg.dial.idstack[id]]) then
				sg.modules.iris.open(id,sg.modules.iris.iris[sg.dial.idstack[id]])
			else
				sg.modules.iris.close(id,sg.modules.iris.iris[sg.dial.idstack[id]])
			end
		end
    end
    if (menu=="Dialing Menu (Gate Dialing)") then
        if (sel==1) then
            sg.dial.abort(id,sg.dial.idstack[id])
        end
		if (sel==2) then
			if (sg.modules.iris.gclosed[sg.dial.idstack[id]]) then
				sg.modules.iris.open(id,sg.modules.iris.iris[sg.dial.idstack[id]])
			else
				sg.modules.iris.close(id,sg.modules.iris.iris[sg.dial.idstack[id]])
			end
		end
    end
    if (menu=="Dialing Menu") then
        if (sel==1) then
            sg.dial.isentering[id]=true
            msg2(id,"Enter a gate address in chat to dial it.")
        end
		if (sel==2) then
			if (sg.modules.iris.gclosed[sg.dial.idstack[id]]) then
				sg.modules.iris.open(id,sg.modules.iris.iris[sg.dial.idstack[id]])
			else
				sg.modules.iris.close(id,sg.modules.iris.iris[sg.dial.idstack[id]])
			end
		end
    end
end

----------------------------
-- IRIS SPAWNER FUNCTIONS --
----------------------------
function sg.modules.iris.screate(ply,gate,type,toggle)
	if (type=="Tauri") then
		sg.modules.iris.image[sg.modules.iris.currentid]=image("gfx/iris.png",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6],1)
		sg.modules.iris.gate[sg.modules.iris.currentid]=gate
		sg.modules.iris.owner[sg.modules.iris.currentid]=ply
		sg.modules.iris.type[sg.modules.iris.currentid]="Tauri"
		sg.modules.iris.closed[sg.modules.iris.currentid]=true
		sg.modules.iris.gclosed[sg.modules.iris.gate[sg.modules.iris.currentid]]=true
		sg.modules.iris.iris[gate]=sg.modules.iris.currentid
		if (toggle) then
			sg.modules.iris.open(0,sg.modules.iris.currentid)
		end
		sg.modules.iris.currentid=sg.modules.iris.currentid+1
	elseif (type=="Atlantis") then
		sg.modules.iris.image[sg.modules.iris.currentid]=image("gfx/iris_atl.png",sg.init.gatepos[gate][5],sg.init.gatepos[gate][6],1)
		imageblend(sg.modules.iris.image[sg.modules.iris.currentid],1)
		sg.modules.iris.gate[sg.modules.iris.currentid]=gate
		sg.modules.iris.owner[sg.modules.iris.currentid]=ply
		sg.modules.iris.type[sg.modules.iris.currentid]="Atlantis"
		sg.modules.iris.closed[sg.modules.iris.currentid]=true
		sg.modules.iris.gclosed[sg.modules.iris.gate[sg.modules.iris.currentid]]=true
		sg.modules.iris.iris[gate]=sg.modules.iris.currentid
		if (toggle) then
			sg.modules.iris.open(0,sg.modules.iris.currentid)
		end
		sg.modules.iris.currentid=sg.modules.iris.currentid+1
	end
end
